# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Union
from . import utilities, tables

class GetPluginsResult:
    """
    A collection of values returned by getPlugins.
    """
    def __init__(__self__, id=None, instance_id=None, plugins=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        __self__.id = id
        """
        The provider-assigned unique ID for this managed resource.
        """
        if instance_id and not isinstance(instance_id, float):
            raise TypeError("Expected argument 'instance_id' to be a float")
        __self__.instance_id = instance_id
        if plugins and not isinstance(plugins, list):
            raise TypeError("Expected argument 'plugins' to be a list")
        __self__.plugins = plugins
class AwaitableGetPluginsResult(GetPluginsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetPluginsResult(
            id=self.id,
            instance_id=self.instance_id,
            plugins=self.plugins)

def get_plugins(instance_id=None,plugins=None,opts=None):
    """
    Use this data source to retrieve information about installed and available plugins for the CloudAMQP instance.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_cloudamqp as cloudamqp

    plugins = cloudamqp.get_plugins(instance_id=cloudamqp_instance["instance"]["id"])
    ```
    ## Argument reference

    * `instance_id` - (Required) The CloudAMQP instance identifier.

    ## Attribute reference

    * `plugins` - (Computed) An array of plugins. Each `plugins` block consists of the fields documented below.

    ***

    The `plugins` block consist of

    * `name`        - (Computed) The type of the recipient.
    * `version`     - (Computed) Rabbit MQ version that the plugins are shipped with.
    * `description` - (Computed) Description of what the plugin does.
    * `enabled`     - (Computed) Enable or disable information for the plugin.

    ## Dependency

    This data source depends on CloudAMQP instance identifier, `cloudamqp_instance.instance.id`.



    The **plugins** object supports the following:

      * `description` (`str`)
      * `enabled` (`bool`)
      * `name` (`str`)
      * `version` (`str`)
    """
    __args__ = dict()


    __args__['instanceId'] = instance_id
    __args__['plugins'] = plugins
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = utilities.get_version()
    __ret__ = pulumi.runtime.invoke('cloudamqp:index/getPlugins:getPlugins', __args__, opts=opts).value

    return AwaitableGetPluginsResult(
        id=__ret__.get('id'),
        instance_id=__ret__.get('instanceId'),
        plugins=__ret__.get('plugins'))
